# Trading frontend

If you are building a trading frontend, here are a few things where Hydromancer tech stack can make your user experience much better.<br>

#### Showing advanced data analytics for each market

You can use an add-on endpoint [perpSnapshot](/readme/rest-api/market-data/perpsnapshot.md)or [spotSnapshot](/readme/rest-api/market-data/spotsnapshot.md)to be able to get entire positioning of all users on Hyperliquid through a single connection. From there, you'd be able to show your users:

* biggest spot holders of a certain coin
* biggest longs/shorts
* change in perp positioning in the last hour

You can also easily embed [liquidationFills](/readme/websocket/liquidationfills.md)to your trading frontend to give your users an easy way to track liquidations currently happening on Hyperliquid.

#### Smart wallet tracking

You can show your users the positioning of multiple other wallets using [batchClearinghouseStates](/readme/rest-api/user-position-data/batchclearinghousestates.md).\
Besides, if your users are tracking certain wallets, you can show them their fills by calling [userFills](/readme/rest-api/historical-data/userfills.md).

#### Multiple charts (coming soon!)

If you are building a pro-tail interface, your users might benefit from advanced, custom timeframes and multiple charts on one screen. These are supported by our candlestick API calls, allowing you to show your users multiple charts with custom timeframes.

#### Enhanced order types

Our non-rate-limited APIs can allow you to implement new order types such as trailing stops or conditional orders.

For conditional orders that require frequent refresh of user positions, use [batchClearinghouseStates](/readme/rest-api/user-position-data/batchclearinghousestates.md)to get the positions of your users.

For conditional orders depending on mark or mid price of any asset, you can use [assetContext](/readme/rest-api/asset-data/assetcontext.md).

***

We also offer features to save your development time and make your product manager's life much easier :)

#### Tracking your users' fills data

You can use [builderFills](/readme/rest-api/historical-data/builderfills.md) websocket or [builderFillsByTime](/readme/rest-api/historical-data/builderfillsbytime.md)REST API to get fills linked to your builder code. This is extremely useful to be able to track what your users are doing currently and how much revenue are you getting.\
The alternative method - getting lz4 files from Hyperliquid which attribute fills to you builder code, has a 1-3 day delay.

#### Tracking your users' order updates

Use [userOrderUpdates](/readme/websocket/userorderupdates.md)websocket to subscribe to all your user and get the orders and order updates of your users through a single connection.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hydromancer.xyz/readme/builder-guides/trading-frontend.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
